
package jwiley.chp10;

import java.awt.Frame;
import java.awt.Button;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.Menu;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.CardLayout;
import java.awt.Panel;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

class layoutWindow extends Frame implements ActionListener
{
    Button buttons[];
    CardLayout cl;

    layoutWindow()
    {
        super("Layout Tester");

        buttons = new Button[5];
        buttons[0] = new Button("One");
        buttons[1] = new Button("Two");
        buttons[2] = new Button("Three");
        buttons[3] = new Button("Four");
        buttons[4] = new Button("Five");

        // start with border Layout
        setLayout(new BorderLayout());
        add("North",buttons[0]);
        add("Center",buttons[1]);
        add("South",buttons[2]);
        add("West",buttons[3]);
        add("East",buttons[4]);

        // add the MenuBar
        MenuBar mBar = new MenuBar();
        setMenuBar(mBar);
        Menu fileMenu = new Menu("File");
        mBar.add(fileMenu);
        Menu layoutMenu = new Menu("Layouts");
        mBar.add(layoutMenu);

        MenuItem mnuExit = new MenuItem("Exit");
        mnuExit.addActionListener(this);
        fileMenu.add(mnuExit);

        MenuItem mnuItems[] = new MenuItem[5];
        mnuItems[0] = new MenuItem("BorderLayout");
        mnuItems[1] = new MenuItem("FlowLayout");
        mnuItems[2] = new MenuItem("GridLayout");
        mnuItems[3] = new MenuItem("GridBagLayout");
        mnuItems[4] = new MenuItem("CardLayout");

        for (int i=0; i < mnuItems.length; i++)
        {
            layoutMenu.add(mnuItems[i]);
            mnuItems[i].addActionListener(this);
        }

        setSize(300,300);
        setLocation(50,50);
        show();
    }

    public void actionPerformed(ActionEvent evt)
    {
        Object target = evt.getSource();
        if (target instanceof MenuItem)
        {
            String label = (String) evt.getActionCommand();
            if (label.equals("Exit"))
            {
                dispose();
                System.exit(0);
            }
            else if (label.equals("BorderLayout"))
            {
                removeAll();
                setLayout(new BorderLayout());
                add("North",buttons[0]);
                add("Center",buttons[1]);
                add("South",buttons[2]);
                add("West",buttons[3]);
                add("East",buttons[4]);
                doLayout();
                repaint();
            }
            else if (label.equals("FlowLayout"))
            {
                removeAll();
                setLayout(new FlowLayout(FlowLayout.LEFT));
                add(buttons[0]);
                add(buttons[1]);
                add(buttons[2]);
                add(buttons[3]);
                add(buttons[4]);
                doLayout();
                repaint();
            }
            else if (label.equals("GridLayout"))
            {
                removeAll();
                setLayout(new GridLayout(0,2));
                add(buttons[0]);
                add(buttons[1]);
                add(buttons[2]);
                add(buttons[3]);
                add(buttons[4]);
                doLayout();
                repaint();
            }
            else if (label.equals("GridBagLayout"))
            {
                removeAll();
                GridBagLayout gbl = new GridBagLayout();
                setLayout(gbl);

                GridBagConstraints c[] = new GridBagConstraints[5];
                for (int i=0; i < 5; i++)
                        c[i] = new GridBagConstraints();

                c[0].gridwidth = 1;
                c[0].gridheight = 1;
                c[0].gridx = 0;
                c[0].gridy = 0;
                add(buttons[0], c[0]);

                c[1].gridwidth = 1;
                c[1].gridheight = 1;
                c[1].gridx = 1;
                c[1].gridy = 1;
                add(buttons[1],c[1]);

                c[2].gridwidth = 1;
                c[2].gridheight = 1;
                c[2].gridx = 2;
                c[2].gridy = 2;
                add(buttons[2],c[2]);

                c[3].gridwidth = 1;
                c[3].gridheight = 1;
                c[3].gridx = 3;
                c[3].gridy = 3;
                add(buttons[3],c[3]);

                c[4].gridwidth = 1;
                c[4].gridheight = 1;
                c[4].gridx = 4;
                c[4].gridy = 4;
                add(buttons[4],c[4]);
                doLayout();
                repaint();
            }
            else if (label.equals("CardLayout"))
            {
                removeAll();
                cl = new CardLayout();
                setLayout(cl);
                Panel p[] = new Panel[5];
                Button nextButton[] = new Button[5];
                for (int i=0; i < 5; i++)
                {
                    p[i] = new Panel();
                    p[i].setLayout(new BorderLayout());
                    nextButton[i] = new Button("Next");
                    nextButton[i].addActionListener(this);
                }

                p[0].add("Center",buttons[0]);
                p[0].add("South", nextButton[0]);
                p[1].add("Center",buttons[1]);
                p[1].add("South", nextButton[1]);
                p[2].add("Center",buttons[2]);
                p[2].add("South", nextButton[2]);
                p[3].add("Center",buttons[3]);
                p[3].add("South", nextButton[3]);
                p[4].add("Center",buttons[4]);
                p[4].add("South", new Button("No More"));

                add("One",p[0]);
                add("Two",p[1]);
                add("Three",p[2]);
                add("Four",p[3]);
                add("Five",p[4]);
                cl.first(this);
                doLayout();
                repaint();
            }
        }
        else if (target instanceof Button)
        {
            String label = (String) evt.getActionCommand();
            if (label.equals("Next"))
            {
                // card Layout - next card
                cl.next(this);
            }
        }
    }

    public static void main (String args[])
    {
        new layoutWindow();
    }
}
