// URLLoadedEvent.java
package jwiley.chp11;

import java.util.EventObject;

/**
 * Event class for the URLDisplay Bean.  This event indicates that
 * the Display Bean has finished loading its object.
 */
public class URLLoadedEvent extends EventObject
{
    /**
     * The object that was just loaded
     */
    private Object loadedObject;

    /**
     * Constructor, takes the Bean that fires the event and the object
     * that was loaded as arguments
     */
    public URLLoadedEvent(Object srcObj, Object urlObj)
    {
        super(srcObj);
        loadedObject = urlObj;
    }

    /**
     * Public accessor method for the loaded object value
     */
    public Object getLoadedObject()
    {
        return loadedObject;
    }
}