// TestMath.java
package jwiley.chp15;

import java.math.BigInteger;
import java.math.BigDecimal;

/** Class to demonstrate operations on BigIntegers and
    BigDecimals. */
public class TestMath
{
    /** main() method to invoke from JVM. */
    public static void main (String args[])
    {
        BigInteger bi1 = new BigInteger("123456789123456789");
        System.out.println("BigInt1: " + bi1);

        BigInteger bi2 = new BigInteger("54235892340857328023480");
        System.out.println("BigInt2: " + bi2);

        System.out.println();
        System.out.println("BigInt1 * BigInt2 = " + bi1.multiply(bi2));
        System.out.println("BigInt2 / BigInt1 = " + bi2.divide(bi1));
        System.out.println("BigInt1 + BigInt2 = " + bi1.add(bi2));
        System.out.println("BigInt1 - BigInt2 = " + bi1.subtract(bi2));
        System.out.println();

        BigDecimal bd1 = new BigDecimal("123456789.123456789123456789");
        System.out.println("BigDecimal1: " + bd1);

        BigDecimal bd2 = new BigDecimal("523423425245345.0083458982792834");
        System.out.println("BigDecimal2: " + bd2);

        System.out.println("BigD1 * BigD2 = " + bd1.multiply(bd2));
        System.out.println("The result as a double: " + (bd1.multiply(bd2)).doubleValue());
    }
}

