// ExpressionTest.java
package jwiley.chp2;

/**
 * Class to test Java expressions.
 * @author Michael C. Daconta
 */
class ExpressionTest
{
    /** Main method to invoke from a JVM. */
    public static void main(String args[])
    {
        System.out.println("Arithmetic expressions");
        float fahr=60.0f, celsius =0;
        celsius = (5.0f/9.0f) * (fahr-32.0f);
        System.out.println("fahrenheit: " + fahr + " celsius: " +
                           celsius);
        System.out.println("");

        System.out.println("Relational and logical expressions");
        System.out.println(fahr > 20.0);
        /* System.out.println((fahr < 20.0) && (1));
           Legal in C but ILLEGAL in Java. */
        System.out.println(((fahr < 20.0) && (true)));
        System.out.println("");

        System.out.println("Casts and conversions in expressions");
        int age=10;
        float gpa = age;
        double salary=30000.3;
        System.out.println(gpa + salary);
        System.out.println((int)(gpa + salary));
        System.out.println("");

        System.out.println("Bitwise expressions");
        System.out.println(100 >> 1);  // division by 2
        System.out.println(age << 1);  // multiplication by 2
        int memoryBlock = (12 + 7) & ~7;
        System.out.println("12 rounded to a power of 8 is " +
                            memoryBlock);
        System.out.println("");

        System.out.println("Order of Evaluation in Expressions");
        int a = 5 & 1 + 2;
        System.out.println(a);
        a = (5 & 1) + 2;
        System.out.println(a);
    }
}