// StringBasics.java
package jwiley.chp2;

/**
 * Class to demonstrate the basics of Java Strings.
 * @author Michael C. Daconta
 * @version 1.1
 */
class StringBasics
{
    /** Main() method to invoke from JVM. */
    public static void main(String args[])
    {
        /* 1) a String is NOT a character array. */
        // char charArray[] = "mike";  ILLEGAL
        char charArray[] = new char[4];
        charArray[0] = 'm';
        charArray[1] = 'i';
        charArray[2] = 'k';
        charArray[3] = 'e';
        // a Java character array is NOT NUL terminated. */
        System.out.println("charArray is " + charArray);
        System.out.println("length of charArray is " +
                                charArray.length);


        /* 2) creating a String object. */
        String myName = "Michael";
        String sentence = new String("I live in a small town.");

        /* 3) get the string length. */
        System.out.println("Length of " + myName +
                           " is " + myName.length());

        /* 4) character access, char is UNICODE NOT ASCII! */
        for (int i=0; i < myName.length(); i++)
                System.out.println("char #" + i +
                                   " is " + (int) myName.charAt(i) +
                                   " which is " +
                (new Character(myName.charAt(i))).toString());


        /* 5) String concatentation. */
        String fullName = myName + " Corey " + "Daconta";
        System.out.println("my fullName is " + fullName);

        /* 6) String comparison */
        if (myName.equals("Michael"))
                System.out.println("My name is Michael.");

        if ("Michael".equals(myName))
                System.out.println("... and Michael is my name.");

        /* 7) String manipulation */
        int idx = sentence.indexOf("small");

        if (idx > 0)
        {
            System.out.println("sentence is : <" + sentence + ">");
            System.out.println("small starts at index: " + idx);
            String smallStr = sentence.substring(idx, idx + "small".length());
            System.out.println("smallStr is " + smallStr);
        }
    }
}
