/** TestTableFrame.java */
package jwiley.chp23;

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;

import java.awt.*;
import java.awt.event.*;

/**
 * Frame to test the JTable component.
 * @author Eric Monk
 */
public class TestTableFrame extends JFrame
{
    /** constructor. */
    public TestTableFrame (String sTitle)
    {
        super(sTitle);

        // create data model
        DatabaseTableModel dataModel = null;

        try {
            dataModel =
                  new DatabaseTableModel("jdbc:odbc:ExampleDB",
                                             "Books");
        } catch (Exception e)
          {
            System.out.println("Cannot get data model. Error: "
                                                    + e.toString());
            System.exit(0);
          }

        // create column model
        DefaultTableColumnModel dtcm = new DefaultTableColumnModel();

        // create columns
        String[] sColumnHeadings = ((DatabaseTableModel) dataModel).getColumnHeadings();

        for (int iCount = 0; iCount < sColumnHeadings.length; iCount++)
        {
            TableColumn column = new TableColumn(sColumnHeadings[iCount]);
    		column.setWidth(100);
            dtcm.addColumn(column);
        }

    	// create table
        JTable table = new JTable(dataModel, dtcm);

        // Put the table and header into a scrollPane
        JScrollPane scrollpane = JTable.createScrollPaneForTable(table);
        getContentPane().add("Center", scrollpane);

        addWindowListener(new WindowAdapter()
                          {
                            public void windowClosing(WindowEvent we)
                            { System.exit(0); }
                          });
        setSize(500, 300);
        show();
    }

    /** main method to invoke from the JVM. */
    public static void main (String args[])
    {
        new TestTableFrame("Test Table Frame");
    }
}
