// ClassAssign.java
package jwiley.chp3;

/**
 * Simple demonstration object.
 */
class simpleObject implements Cloneable
{
    /** integer. */
    private int a;

    /** constructor. */
    simpleObject(int inA)
    { a = inA; }

    /** accessor. */
    int getA()
    { return a; }

    /** mutator. */
    void setA(int inA)
    { a = inA; }

    /** clone method. */
    public Object clone()
    {
        Object copy = null;
        try
        {
            copy = super.clone();
        } catch(CloneNotSupportedException cne)
          {
            cne.printStackTrace();
            System.exit(1);
          }
        return copy;
    }
}

/**
 * Class demonstrating both shallow and deep copies.
 */
class classAssign
{
        public static void main(String args[])
        {
            simpleObject myObject = new simpleObject(10);
            System.out.println("myObject a: " + myObject.getA());
            simpleObject yourObject = new simpleObject(20);
            System.out.println("yourObject a: " + yourObject.getA());

            // reference assignment
            yourObject = myObject; // assignment
            System.out.println("yourObject a: " + yourObject.getA());

            // true copy
            simpleObject trueCopy = null;
            trueCopy = (simpleObject) myObject.clone();
            trueCopy.setA(30);
            System.out.println("myObject a: " + myObject.getA());
            System.out.println("trueCopy a: " + trueCopy.getA());
        }
}
