// Loan.java
package jwiley.chp3;

import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * Class to represent a commercial loan.
 * @author Michael C. Daconta
 * @version 1.2
 */
class Loan
{
    /** principal of loan. */
    private float principal;
    /** interest rate of loan. */
    private float interestRate;
    /** term of loan. */
    private int numYears;

    /** constructor. */
    Loan(float thePrincipal, float theInterest,
            int theYearsToRepay)
    {
        principal = thePrincipal;
        interestRate = theInterest;
        numYears = theYearsToRepay;
    }

    /** accessor. */
    float getPrincipal()
    { return principal; }

    /** accessor. */
    float getInterestRate()
    { return interestRate; }

    /** accessor. */
    int getYears()
    { return numYears; }

    /** method to calculate the payment
        of this loan. */
    double calculatePayment()
    {
        // assuming monthly payments
        double interest = interestRate/100;
        double payment = (interest * principal/12) /
                         (1 - Math.pow(interest/12 + 1,
                                        -12*numYears));
        return payment;
    }

    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
        Float principal = new Float(0);
        Float interest = new Float(0);
        int theYears = 0;
        try
        {
            BufferedReader br = new BufferedReader(new
                                    InputStreamReader(System.in));
            System.out.print("Enter Principal of Loan: ");
            System.out.flush();
            String principalStr = br.readLine();
            principal = Float.valueOf(principalStr);
            System.out.print("Enter annual Interest rate percentage (i.e. 9.5): ");
            System.out.flush();
            String interestStr = br.readLine();
            interest = Float.valueOf(interestStr);
            System.out.print("Enter number of years of Loan: ");
            System.out.flush();
            String yearsStr = br.readLine();
            theYears = Integer.parseInt(yearsStr);
        } catch (java.io.IOException e)
          {
            System.out.println("IO error. Rerun program.");
            System.exit(1);
          }

        Loan theLoan = new Loan(principal.floatValue(),
                                interest.floatValue(),
                                theYears);

        double monthlyPayment = theLoan.calculatePayment();
        System.out.println("Your monthly payment is : " +
                                monthlyPayment);
    } // end of main()
} // end of class Loan {}
