// RTTI.cpp - a demonstration of RTTI in C++
#include <typeinfo.h>
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

class graphicImage {
        protected:
        	char name[80];
        	int pixelsHigh, pixelsWide;
        	unsigned char **bitmap;

		public:
        graphicImage()
        {
                pixelsHigh = pixelsWide = 0;
                strcpy(name,"graphicImage");
        }

        graphicImage(char * filename)
        {
                // process file, store bitmap
                cout << "Process " << filename << endl;
        }

        virtual void display()
        {
               	cout << "Display a generic image." << endl;
                for (int i=0; i < pixelsHigh; i++)
                        for (int j=0; j < pixelsWide; j++)
                                ; // draw each pixel
        }

        char* getName()
        {
                return name;
        }
};

class GIFimage : public graphicImage {
        // GIF data members

	    public:
        GIFimage()
        {
                // GIF constructor
                strcpy(name,"GIFimage");
        }

        void display()
        {
                // display the GIF file in a GIF-specific way
                cout << "Display a GIF file." << endl;
        }
};

class PICTimage : public graphicImage {
        // PICT data members

	    public:
        PICTimage()
        {
                // PICT constructor
                strcpy(name,"PICTimage");
        }

        void display()
        {
                // display the PICT in a PICT-specific way
                cout << "Display a PICT file." << endl;
        }
};

void processFile(graphicImage *type)
{
	if (typeid(GIFimage) == typeid(*type))
	{	
 		((GIFimage *)type)->display(); 
	}
	else if (typeid(PICTimage) == typeid(*type))
	{
		((PICTimage *)type)->display();
	}
	else
		cout << "Unknown type! <" << (typeid(*type)).name() 
			<< ">" << endl;
}
       
void main(int argc, char **argv)
{
	graphicImage *gImage = new GIFimage();
	graphicImage *pImage = new PICTimage();

	processFile(gImage);
	processFile(pImage); 
}
