// TestExceptions.java
package jwiley.chp3;

/**
 * Class to represent an erroneous result exception.
 */
class ResultTooLarge extends Exception
{
    /** constructor. */
    ResultTooLarge(String msg)
    {
        super(msg);
    }
}

/**
 * Class to demonstrate throwing and catching exceptions.
 */
class TestExceptions
{
    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
        int a=100, b=2;
        try
        {
            int result = a/b;
            if (result > 5)
            {
                throw new ResultTooLarge(result + " is too Large.");
            }
        } catch (ResultTooLarge e)
          {
            System.out.println("Caught the result too large.");
            System.out.println(e.getMessage());
          }
          finally
          {
            System.out.println("Finally will always be run.");
            System.out.println("Even if exceptions are caught.");
          }
    }
}
