// PostFix.java
package jwiley.chp7;

import java.util.Stack;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

/** Class that represents a PostFix calculator.
    Designed also to demonstrate the Java stack container class. */
class PostFix
{
    /** main() method to invoke from the JVM. */
    public static void main(String args[])
    {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        System.out.println("Simple PostFix calculator.");
        String input=null;

        System.out.println("Valid operations are + - / *");
        System.out.println("Enter 'q' to quit.");

        Stack numberStack = new Stack();

        do
        {
            System.out.print(": ");
            System.out.flush();
            try
            {
                input = br.readLine();
            } catch (IOException ioe)
              {
                System.out.println("IO Error.");
                System.exit(1);
              }

            if (input.equals("+"))
            {
                if (numberStack.size() >= 2)
                {
                    Integer a = (Integer) numberStack.pop();
                    Integer b = (Integer) numberStack.pop();
                    int total = a.intValue() + b.intValue();
                    System.out.println(total);
                    numberStack.push(new Integer(total));
                }
                else
                {
                    System.out.println("In Postfix notation " +
                                       "there must be 2 numbers " +
                                       "and then an operator.");
                }
            }
            else if (input.equals("-"))
            {
                if (numberStack.size() >= 2)
                {
                    Integer a = (Integer) numberStack.pop();
                    Integer b = (Integer) numberStack.pop();
                    int total = b.intValue() - a.intValue();
                    System.out.println(total);
                    numberStack.push(new Integer(total));
                }
                else
                {
                    System.out.println("In Postfix notation " +
                                       "there must be 2 numbers " +
                                       "and then an operator.");
                }
            }
            else if (input.equals("/"))
            {
                if (numberStack.size() >= 2)
                {
                    Integer a = (Integer) numberStack.pop();
                    Integer b = (Integer) numberStack.pop();
                    if (a.intValue() != 0)
                    {
                            int total = b.intValue() / a.intValue();
                            System.out.println(total);
                            numberStack.push(new Integer(total));
                    }
                    else
                            System.out.println("Divide by 0 is illegal.");
                }
                else
                {
                    System.out.println("In Postfix notation " +
                                       "there must be 2 numbers " +
                                       "and then an operator.");
                }
            }
            else if (input.equals("*"))
            {
                if (numberStack.size() >= 2)
                {
                    Integer a = (Integer) numberStack.pop();
                    Integer b = (Integer) numberStack.pop();
                    int total = a.intValue() * b.intValue();
                    System.out.println(total);
                    numberStack.push(new Integer(total));
                }
                else
                {
                    System.out.println("In Postfix notation " +
                                       "there must be 2 numbers " +
                                       "and then an operator.");
                }
            }
            else if (input.equals("="))
            {
                // show top of stack
                if (!numberStack.empty())
                {
                    Integer tot = (Integer) numberStack.pop();
                    System.out.println("Total : " + tot);
                }
                else
                {
                    System.out.println("Stack is empty!");
                }
            }
            else if (Character.isDigit(input.charAt(0)))
            {
                int num = Integer.parseInt(input);
                numberStack.push(new Integer(num));
            }
            else if (!input.equals("q")) // unknown input
            {
                System.out.println("Unknown input <" +
                                        input + ">");
            }
        } while (!input.equals("q"));
    }
}
